/**
 **	Query.H
 **
 **	Published / author: 2001-02-15 / grymse@telia.com
 **/

/*
Copyright (C) 2001  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _QUERY_HH
#define _QUERY_HH

//#include "Database.h"


class Query {
public:
	Query::Query(void);
	Query::Query(Database *dbin);
	short Query::execute(char *sql);		// query, no result
	Query::Query(Database *dbin,char *sql);
	Query::~Query(void);

// methods using db specific api calls

	MYSQL_RES *Query::get_result(char *sql);	// query, result
	void Query::free_result(void);
	MYSQL_ROW Query::fetch_row(void);
	long Query::insert_id(void);
	long Query::num_rows(void);

// data retreival methods

	char *Query::getstr(int x);
	char *Query::getstr(void);
	double Query::getnum(int x);
	long Query::getval(int x);
	double Query::getnum(void);
	long Query::getval(void);
	double Query::get_num(char *sql);
	long Query::get_count(char *sql);
	char *Query::get_string(char *sql);
	void Query::debug(short val);
	void Query::syslog(short val);

//MYSQL_FIELD *	STDCALL mysql_fetch_field(MYSQL_RES *result);

	MYSQL_FIELD *Query::fetch_field(void);
	char *Query::fetch_fieldname(void);
	void Query::safestr(char *s);
	void Query::unsafestr(char *s);
	char *Query::xmlsafestr(char *s);

private:
	Database *db;
	OPENDB *odb;
#ifdef _mysql_h
	MYSQL_RES *res;
	MYSQL_ROW row;
#endif
	short rowcount;
	short _debug;
	short _syslog;
};


#endif // _QUERY_HH
